#if defined(__FB_PCOS__)
  #define slash "\"
#elseif defined(__FB_UNIX__)
  #define slash "/"
#endif
#include once "vbcompat.bi"
#include once "fbgfx.bi"

#define HexGroesse       30
#define HexRadius        16
#define HexXplus         Hexgroesse\2
#define HexYplus         -HexGroesse\2
#define FeldBreit        25
#define FeldHoch         18
#define FeldXPlus        200
#define InfoX            20
#define InfoY            300
#define InfoHoch         250
#define SteuerX          20
#define SteuerY          20
#define SteuerBreit      180
#define SteuerHoch       250
#define Schrittezahl     10

#define MaxFeldarbeiter  9
#define MaxMinenarbeiter 99
#define MaxSammler       99
#define MaxKrieger       99

#define ae              !"\132" '
#define oe              !"\148" '
#define ue              !"\129" '
#define ss              !"\225" '

#define FarbeHex        &h555555
#define FarbeSpieler    &h3333ff
#define FarbeMitspieler &h33ff33
#define FarbeGegner     &hff3333
#define Wartezeit       .1

enum Feldart explicit
  Leer = 0, Haus, Mine
  Garten0, Garten1, Garten2, Garten3, Garten4, Garten5
  Arbeiter1, Arbeiter2
end enum

enum Arbeiterwert explicit
  Daheim = 1, LaufHeim, LaufJagen, LaufPflanzen, LaufErnten = 22 
end enum

type TypFeld
  as Feldart art
  as integer besitzer
end type

type TypFigur
  as integer x, y, neuX, neuY, zielX, zielY, arbeitX, arbeitY, warte, wert, typ
  declare sub weiter
end type

type TypGarten
  as integer wert, x, y
end type

type TypSpieler
  as integer hausX, hausY
  as integer kinderAnz, kinderFeld, kinderMine
  as integer kriegerAnz
  as integer suessware, dollar, fuellung
end type

type TypSpielopt
  as integer typ, fuellZiel, fuellAktuell, zeit, dollar, suess, schaden
  as integer fallen, fallenprod
  as integer inaktivFeld, inaktivFeldarb, inaktivMinen, inaktivSammler, inaktivKrieger, inaktivFalle
  as integer zielSuesses, zielFuellung, zielDollar, zielAngriff
  as TypFigur feldarbeiter(1 to MaxFeldarbeiter), minenarbeiter(1 to MaxMinenarbeiter)
  as TypFigur sammler(1 to MaxSammler), krieger(1 to MaxKrieger)
  as TypGarten garten(1 to 18)
  as integer anzArbeiter, anzFeldarbeiter, anzMinenarbeiter, anzSammler
  as integer anzGarten, anzKrieger, hausX, hausY
  declare sub gartenBerechnen
end type

sub TypFigur.weiter
  with this
    .x = .neuX
    .y = .neuY
    if .warte > 0 then
      .warte -=1                                                  ' Wartezeit absitzen
      exit sub
    end if
    if .x = .zielX then
      if .y = .zielY then
        exit sub                                                  ' Ziel schon erreicht
      else
        .neuY += sgn(.zielY - .y)                                 ' nur noch senkrecht laufen
        exit sub
      end if
    end if
    if .y = .zielY then .neuX += sgn(.zielX - .x) : exit sub      ' nur noch waagrecht laufen
    dim as integer dx = abs(.zielX-.x), dy = abs(.zielY-.y)
    if dx mod 2 then
      dx += iif((.x mod 2) = 0 xor zielY > .y, 1, -1)
    end if
    if dx < 2*dy then
      .neuY += sgn(.zielY - .y)
    else
      .neuX += sgn(.zielX - .x)
      if dx = 2*dy andalso ((.x mod 2) = 1) xor (.y > .zielY) then .neuY += sgn(zielY - .y)
    end if
  end with
end sub

sub TypSpielopt.gartenBerechnen
  with this
    .anzGarten = 0
    for i as integer = 1 to 18
      select case as const i
        case 15 to 17     : .garten(i).x = .hausX - 2
        case 5, 6, 14, 18 : .garten(i).x = .hausX - 1
        case 1, 4, 7, 13  : .garten(i).x = .hausX
        case 2, 3, 8, 12  : .garten(i).x = .hausX + 1
        case else         : .garten(i).x = .hausX + 2
      end select
      select case as const i
        case 7            : .garten(i).y = .hausY - 2
        case 1, 9, 17     : .garten(i).y = .hausY - 1
        case 10, 16       : .garten(i).y = .hausY
        case 4, 11, 15    : .garten(i).y = .hausY + 1
        case 13           : .garten(i).y = .hausY + 2
        case 2, 3         : .garten(i).y = .hausY - 3 + i + (.hausX mod 2)
        case 5, 6         : .garten(i).y = .hausY + 5 - i + (.hausX mod 2)
        case 8, 18        : .garten(i).y = .hausY - 2 - (.hausX mod 2)
        case 12, 14       : .garten(i).y = .hausY + 1 - (.hausX mod 2)
      end select
      if .garten(i).wert > 0 then .anzGarten += 1
    next
  end with
end sub


dim as TypFeld feld(FeldBreit, FeldHoch)
dim shared as FB.IMAGE ptr img(10), hintergrund

declare function add(l() as TypFigur, x as integer, y as integer, _
                     zx as integer = 0, zy as integer = 0) as integer
declare sub hexfeld(fx as integer, fy as integer, f as TypFeld)
declare sub info(wert as TypSpielopt)
declare function pruefeButtons(opt as TypSpielopt) as integer
declare function rechtsbuendig overload (s as string, anz as integer) as string
declare function rechtsbuendig(i as integer, anz as integer) as string
declare sub steuerleiste(opt as TypSpielopt)
declare sub zeichne overload (opt as TypSpielopt, schrittweite as integer)
declare sub zeichne(liste() as TypFigur, schritt as integer)

sub ende destructor
  ' aufraeumen am Ende des Prgramms
  for i as integer = 1 to ubound(img)
    imagedestroy img(i)
  next
  imagedestroy hintergrund
end sub

function add(liste() as TypFigur, x as integer, y as integer, _
             zx as integer = 0, zy as integer = 0) as integer
  ' neuen Arbeiter o. ae. in der Liste einfuegen
  for i as integer = 1 to ubound(liste)
    with liste(i)
      if .wert = 0 then
        .neuX  = x
        .neuY  = y
        .zielX = iif(zx = 0, x, zx)
        .zielY = iif(zy = 0, y, zy)
        .arbeitX = .zielX
        .arbeitY = .zielY
        .wert  = 1
        .weiter
        .typ = int(rnd*2)
        return -1
      end if
    end with
  next
  return 0
end function

sub hexfeld(fx as integer, fy as integer, f as TypFeld)
  ' zeichnet ein einzelnes Hex
  dim as integer x = HexXplus + fx*HexRadius*3/2 + FeldXPlus
  dim as integer y = HexYplus + (fy + .5*(fx mod 2))*HexGroesse
  dim as integer farbe
  select case f.besitzer
    case 0      : farbe = FarbeHex
    case 1      : farbe = FarbeSpieler
    case 2 to 4 : farbe = FarbeMitspieler
    case 5 to 8 : farbe = FarbeGegner
  end select
  put (x+6, y+6), img(0), pset
  line (x, y+HexGroesse\2)-step(HexRadius\2, HexGroesse\2), farbe
  line -step(HexRadius, 0), farbe
  line -step(HexRadius\2, -HexGroesse\2), farbe
  line -step(-HexRadius\2, -HexGroesse\2), farbe
  line -step(-HexRadius, 0), farbe
  line -step(-HexRadius\2, HexGroesse\2), farbe
  if f.art <> Feldart.Leer then put (x+6, y+6), img(f.art), trans
end sub

sub info(opt as TypSpielopt)
  ' Anzeige der allgemeinen Spiel-Informationen
  screenlock
  line (InfoX, InfoY)-(FeldXPlus+9, InfoY+InfoHoch), 0, bf
  draw string (InfoX, InfoY), "ALLGEMEINE DATEN"
  line (InfoX, InfoY+8)-step(128, 0)
  with opt
    draw string (InfoX, InfoY+30),  "F"ue"llung ben"oe"tigt:  " & rechtsbuendig(.fuellZiel,        4)
    draw string (InfoX, InfoY+40),  "F"ue"llung erreicht:  "    & rechtsbuendig(.fuellAktuell,     4)
    draw string (InfoX, InfoY+60),  "Restzeit (sec):    "       & rechtsbuendig(.zeit,             4)
    draw string (InfoX, InfoY+100), "gesparte Dollar:   "       & rechtsbuendig(.dollar,           4)
    draw string (InfoX, InfoY+110), "S"ue ss"igkeiten:       "  & rechtsbuendig(.suess,            4)
    draw string (InfoX, InfoY+130), "Krieger:           "       & rechtsbuendig(.anzKrieger,       4)
    draw string (InfoX, InfoY+140), !"\237 Gesundheit:      "   & rechtsbuendig(0,                 3) & "%"
    draw string (InfoX, InfoY+170), "Arbeiter (gesamt): "       & rechtsbuendig(.anzArbeiter,      4)
    draw string (InfoX, InfoY+180), "Arbeiter (Felder): "       & rechtsbuendig(.anzFeldarbeiter,  4)
    draw string (InfoX, InfoY+190), "Arbeiter (Minen):  "       & rechtsbuendig(.anzMinenarbeiter, 4)
    draw string (InfoX, InfoY+200), "Arbeiter (J"ae"ger):  "    & rechtsbuendig(.anzSammler,       4)
    draw string (InfoX, InfoY+230), "S"ue ss"igkeitenfallen: "  & rechtsbuendig(.fallen,           4)
    draw string (InfoX, InfoY+240), "Fallenproduktion: "        & rechtsbuendig(.fallenprod,       4) & "%"
  end with
  screenunlock
end sub

function pruefeButtons(opt as TypSpielopt) as integer
  ' prueft in der Steuerleiste, ob ein Button gedrueckt wurde
  dim as integer mx, my, mb
  getmouse mx, my,, mb
  if mb <> 1 then return 0
  if opt.inaktivFeldarb = 0 and opt.suess >= 50 and opt.anzFeldarbeiter < opt.anzGarten/2 then
    if mx > SteuerX and my > SteuerY and mx < SteuerX+SteuerBreit and my < SteuerY+20 then return 1
  end if
  if opt.inaktivMinen = 0 and opt.suess >= 50 then
    if mx > SteuerX and my > SteuerY+35 and mx < SteuerX+SteuerBreit and my < SteuerY+55 then return 2
  end if
  if opt.inaktivSammler = 0 and opt.suess >= 50 then
    if mx > SteuerX and my > SteuerY+70 and mx < SteuerX+SteuerBreit and my < SteuerY+90 then return 3
  end if
  if opt.inaktivKrieger = 0 and opt.dollar >= 30 then
    if mx > SteuerX and my > SteuerY+115 and mx < SteuerX+SteuerBreit and my < SteuerY+135 then return 4
  end if
  if opt.inaktivFalle = 0 and opt.suess >= 20 then
    if mx > SteuerX and my > SteuerY+150 and mx < SteuerX+SteuerBreit and my < SteuerY+170 then return 5
    if mx > SteuerX and my > SteuerY+185 and mx < SteuerX+SteuerBreit and my < SteuerY+205 then return 6
  end if
  if opt.inaktivFeld = 0 and opt.suess >= 10 and opt.dollar >= 10 then
    if mx > SteuerX and my > SteuerY+230 and mx < SteuerX+SteuerBreit and my < SteuerY+250 then return 7
  end if
end function

function rechtsbuendig(s as string, anz as integer) as string
  ' gibt den String rechtsbuendig zurueck
  if len(s) > anz then return right(s, anz) else return space(anz-len(s)) & s
end function

function rechtsbuendig(i as integer, anz as integer) as string
  ' gibt die Zahl als rechtsbuendigen String zurueck
  return rechtsbuendig(str(i), anz)
end function

sub steuerleiste(opt as TypSpielopt)
  ' zeigt die Buttons der Steuerleiste an
  screenlock
  line (SteuerX, SteuerY)-step(SteuerBreit, SteuerHoch), 0, bf

  if opt.inaktivFeldarb or opt.suess < 50 _
     or opt.anzFeldarbeiter >= opt.anzGarten/2 then color &h707070 else color &hffffff
  line (SteuerX, SteuerY)-step(SteuerBreit, 20),, b
  line (SteuerX+1, SteuerY+1)-step(SteuerBreit-2, 18),, b
  draw string(SteuerX+SteuerBreit\2-4*18, SteuerY+7), "neuer Feldarbeiter"

  if opt.inaktivMinen or opt.suess < 50 then color &h707070 else color &hffffff
  line (SteuerX, SteuerY+35)-step(SteuerBreit, 20),, b
  line (SteuerX+1, SteuerY+36)-step(SteuerBreit-2, 18),, b
  draw string(SteuerX+SteuerBreit\2-4*19, SteuerY+42), "neuer Minenarbeiter"

  if opt.inaktivSammler or opt.suess < 50 then color &h707070 else color &hffffff
  line (SteuerX, SteuerY+70)-step(SteuerBreit, 20),, b
  line (SteuerX+1, SteuerY+71)-step(SteuerBreit-2, 18),, b
  draw string(SteuerX+SteuerBreit\2-4*19, SteuerY+77), "neuer S"ue ss"warenj"ae"ger"
  
  if opt.inaktivKrieger or opt.dollar < 30 then color &h707070 else color &hffffff
  line (SteuerX, SteuerY+115)-step(SteuerBreit, 20),, b
  line (SteuerX+1, SteuerY+116)-step(SteuerBreit-2, 18),, b
  draw string(SteuerX+SteuerBreit\2-4*13, SteuerY+122), "neuer Krieger"

  if opt.inaktivFalle or opt.suess < 20 then color &h707070 else color &hffffff
  line (SteuerX, SteuerY+150)-step(SteuerBreit, 20),, b
  line (SteuerX+1, SteuerY+151)-step(SteuerBreit-2, 18),, b
  draw string(SteuerX+SteuerBreit\2-4*19, SteuerY+157), "Falle produzieren"

  line (SteuerX, SteuerY+185)-step(SteuerBreit, 20),, b
  line (SteuerX+1, SteuerY+186)-step(SteuerBreit-2, 18),, b
  draw string(SteuerX+SteuerBreit\2-4*17, SteuerY+193), "Falle postieren"
  
  if opt.inaktivFeld or opt.suess < 10 or opt.dollar < 10 then color &h707070 else color &hffffff
  line (SteuerX, SteuerY+230)-step(SteuerBreit, 20),, b
  line (SteuerX+1, SteuerY+231)-step(SteuerBreit-2, 18),, b
  draw string(SteuerX+SteuerBreit\2-4*11, SteuerY+237), "Feld kaufen"

  screenunlock
  color &hffffff
end sub

sub zeichne(opt as TypSpielopt, schrittweite as integer)
  ' zeichnet alle variablen Spielelemente
  dim as integer x = opt.hausX, y = opt.hausY - 1
  for i as integer = 1 to 18
    select case as const i
      case 3, 10, 11 : y += 1
      case 6, 16, 17 : y -= 1
      case 7 : if x mod 2 then y -= 1 else y -= 2
      case 2, 4, 8, 9, 12, 13 : if x mod 2 then y += 1
      case 5, 14, 15, 18      : if (x mod 2) = 0 then y -= 1
    end select
    select case as const i
      case 2, 7, 8, 9, 18 : x += 1
      case 4, 5, 12 to 15 : x -= 1
    end select
    if opt.garten(i).wert = 0 then continue for
    if x < 1 or y < 1 or x > FeldBreit or y > FeldHoch then continue for
    if schrittweite = Schrittezahl andalso opt.garten(i).wert > 2 and opt.garten(i).wert < 22 then opt.garten(i).wert += 1
    hexfeld x, y, type<TypFeld>(Feldart.Garten0 + opt.garten(i).wert\4, opt.typ)
  next  
  zeichne opt.feldarbeiter(), schrittweite
  zeichne opt.minenarbeiter(), schrittweite
  zeichne opt.sammler(), schrittweite
  hexfeld opt.hausX, opt.hausY, type<TypFeld>(Feldart.Haus, opt.typ)
end sub

sub zeichne(liste() as TypFigur, schritt as integer)
  ' zeichnet alle Elemente der angegebenen Liste
  for i as integer = 1 to ubound(liste)
    with liste(i)
      if liste(i).wert = 0 then continue for
      dim as integer x1 = HexXplus + .x*HexRadius*3/2 + FeldXPlus + 6
      dim as integer y1 = HexYplus + (.y + .5*(.x mod 2))*HexGroesse + 6
      dim as integer x2 = HexXplus + .neuX*HexRadius*3/2 + FeldXPlus + 6
      dim as integer y2 = HexYplus + (.neuY + .5*(.neuX mod 2))*HexGroesse + 6
      put (x1 + schritt*(x2-x1)\Schrittezahl, y1 + schritt*(y2-y1)\Schrittezahl), _
          img(Feldart.Arbeiter1 + .typ), trans
    end with
  next
end sub
